package com.application;

import org.restlet.ext.xml.DomRepresentation;
import org.restlet.resource.ResourceException;
import org.restlet.resource.ServerResource;

public class GameServerResource extends ServerResource implements GameResource {
    private JdbcService service;

    @Override
    protected void doInit()throws ResourceException {
        service = JdbcService.getInstance();
    }
    @Override
    public DomRepresentation getRequests() {        // id = userId
        return service.getGameRequests(Integer.parseInt(getAttribute("id")), false);
    }

    @Override
    public DomRepresentation getCompletedRequests() {        // id = userId
        return service.getGameRequests(Integer.parseInt(getAttribute("id")), true);
    }

    @Override
    public String addUpdateRequest(DomRepresentation request) {
        if(getAttribute("requestId") == null){
            return service.addGameRequest(request, false);  // Returns requestId
        }
        return service.updateGameRequest(Integer.parseInt(getAttribute("requestId")), Integer.parseInt(getAttribute("winnerId")),
                Integer.parseInt(getAttribute("winnerScore")));  // Returns number of rows affected
    }

    @Override
    public String addRandomRequest(DomRepresentation request) {
        return service.addGameRequest(request, true);
    }

    @Override
    public String removeRequest() {            // id = requestId
        return service.deleteGameRequest(Integer.parseInt(getAttribute("id")));
    }
}
